using System;
using System.IO;
using System.Text;

namespace bmp2wav
{
	class MainClass
	{
		public static void Main(string[] args)
		{
			new MainClass().rin(args);
		}
		
		void rin(string[] args)
		{
			//Console.WriteLine(Math.Log(2));
			//return;
			ass(args);
		}
		void ass(string[] args)
		{
			//args = new string[]{"brs"};
			byte[] raw = File.ReadAllBytes(args[0] + ".bmp");
			int w = BitConverter.ToInt32(raw, 0x12);
			int h = BitConverter.ToInt32(raw, 0x16);
			Console.WriteLine(w+"x"+h);
			int bal = 0; // bmp align
			int[][] img = new int[h][];
			int min = 255, max = 0;
			for (int y = h-1; y >= 0; y--)
			{
				img[y] = new int[w];
				for (int x = 0; x < w; x++)
				{
					// 0x36; first bit; last row LTR/BGR
					img[y][x] = raw[(h-y-1)*w*3 + x*3 + bal + 0x36 - 1];
					min = Math.Min(min, img[y][x]);
					max = Math.Max(max, img[y][x]);
				}
				bal += (w * 3) % 4;
			}
			double mul = (max-min)/256.0;
			for (int y = 0; y < h; y++)
			{
				for (int x = 0; x < w; x++)
				{
					img[y][x] = (int)((img[y][x] - min) * mul);
				}
			}
			char[] aa = {
				'▘','▀','▝',
				'▖','▄','▗',
				'▌','▚','▞','▐',
				'▟','▙','▜','▛',
				'█','┃','━',' '
			};
			double[][] aav = {
				new double[] { 1,1,0,0, 1,1,0,0, 0,0,0,0, 0,0,0,0 }, // |▘|
				new double[] { 1,1,1,1, 1,1,1,1, 0,0,0,0, 0,0,0,0 }, // |▀|
				new double[] { 0,0,1,1, 0,0,1,1, 0,0,0,0, 0,0,0,0 }, // |▝|
				new double[] { 0,0,0,0, 0,0,0,0, 1,1,0,0, 1,1,0,0 }, // |▖|
				new double[] { 0,0,0,0, 0,0,0,0, 1,1,1,1, 1,1,1,1 }, // |▄|
				new double[] { 0,0,0,0, 0,0,0,0, 0,0,1,1, 0,0,1,1 }, // |▗|
				new double[] { 1,1,0,0, 1,1,0,0, 1,1,0,0, 1,1,0,0 }, // |▌|
				new double[] { 1,1,0,0, 1,1,0,0, 0,0,1,1, 0,0,1,1 }, // |▚|
				new double[] { 0,0,1,1, 0,0,1,1, 1,1,0,0, 1,1,0,0 }, // |▞|
				new double[] { 0,0,1,1, 0,0,1,1, 0,0,1,1, 0,0,1,1 }, // |▐|
				new double[] { 0,0,1,1, 0,0,1,1, 1,1,1,1, 1,1,1,1 }, // |▟|
				new double[] { 1,1,0,0, 1,1,0,0, 1,1,1,1, 1,1,1,1 }, // |▙|
				new double[] { 1,1,1,1, 1,1,1,1, 0,0,1,1, 0,0,1,1 }, // |▜|
				new double[] { 1,1,1,1, 1,1,1,1, 1,1,0,0, 1,1,0,0 }, // |▛|
				new double[] { 1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1 }, // |█|
				new double[] { 0,1,1,0, 0,1,0,0, 0,1,1,0, 0,1,0,0 }, // |┃| // tuned
				new double[] { 0,0,0,0, 1,0,1,0, 0,1,0,1, 0,0,0,0 }, // |━| // tuned
				new double[] { 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0 }  // | |
			};
			for (int a = 0; a < aav.Length; a++)
			{
				for (int b = 0; b < aav[a].Length; b++)
				{
					aav[a][b] = aav[a][b] == 1?1:0.25;
				}
			}
			int aas = 18; //12;
			StringBuilder sb = new StringBuilder();
			for (int y = 0; y < h-aas; y+=aas)
			{
				for (int x = 0; x < w-aas; x+=aas)
				{
					int[][] amp = new int[4][];
					for (int i = 0; i < 4; i++)
					{
						amp[i] = new int[4];
						for (int j = 0; j < 4; j++)
						{
							amp[i][j] = 0;
							for (int ay = 0; ay < aas/4; ay++)
							{
								for (int ax = 0; ax < aas/4; ax++)
								{
									amp[i][j] += img[y+i*(aas/4)+ay][x+j*(aas/4)+ax];
								}
							}
							amp[i][j] /= (aas/4)*(aas/4);
						}
					}
					int aam = Int32.MinValue, aai = 0;
					for (int aan = 0; aan < aav.Length; aan++)
					{
						double sum = 0;
						double div = 0;
						for (int i = 0; i < 4; i++)
						{
							for (int j = 0; j < 4; j++)
							{
								double fac = aav[aan][i*4+j];
								sum += fac * amp[i][j];
								div += fac;
							}
						}
						sum /= div;
						if (sum > aam)
						{
							aai = aan;
							aam = (int)sum;
						}
					}
					//int c = (int)((img[y][x]/256.0) * 24.0);
					int c1 = 0;
					int d1 = 0;
					for (int i = 0; i < 4; i++)
					{
						for (int j = 0; j < 4; j++)
						{
							if (aav[aai][i*4+j] >= 0.9)
							{
								c1 += amp[i][j];
								d1++;
							}
						}
					}
					int c2 = 0;
					int d2 = 0;
					for (int i = 0; i < 4; i++)
					{
						for (int j = 0; j < 4; j++)
						{
							if (aav[aai][i*4+j] < 0.9)
							{
								c2 += amp[i][j];
								d2++;
							}
						}
					}
					int tc1 = (int)((c1 / (d1 * 256.0)) * 24.0);
					int tc2 = (int)((c2 / (d2 * 256.0)) * 24.0);
					//sb.Append(c1 + ":" + c2 + "/");
					tc1 = Math.Min(Math.Max(tc1, 0), 24);
					tc2 = Math.Min(Math.Max(tc2, 0), 24);

					sb.AppendFormat("{0}[38;5;{1}m{0}[48;5;{2}m{3}", (char)27, 232+tc1, 232+tc2, aa[aai]);
				}
				//sb.AppendLine();
				sb.AppendLine((char)27 + "[0m");
			}
			Console.WriteLine(sb.ToString());
			Random rnd = new Random();
			int spp = 500; //315; //4410; //700;
			spp = 4410;
			double bdw = 22000.0 / h;
			double vol = 393216.0 / h;
			int[] phase = new int[h];
			double[] hz = new double[h];
			double[] namp = new double[h];
			double[] oamp = new double[h];
			byte[] buf = new byte[spp * w * 2 + 0x2C];
			double logmul = 22000.0 / Math.Pow(h, Math.E); //v01,v02
			//double logmul = 22000.0 / Math.Pow(h, 10); //v03
			//double logmul = 22000.0 / Math.Log(h); //v04
			//double logmul = 22000.0 / Math.Pow(h, 64); //v05
			//double logmul = 22000.0 / Math.Log(h, Math.E); //v06
			for (int a = 0; a < h; a++)
			{
				phase[a] = rnd.Next(22050);
				//hz[a] = bdw * (h-a-1); //linear,org
				hz[a] = Math.Pow(h-a-1, Math.E) * logmul; //v01
				//hz[a] = Math.Pow(h-a-1, Math.E * 2) * logmul * 2; //v02
				//hz[a] = Math.Pow(h-a-1, 10) * logmul; //v03
				//hz[a] = Math.Log(h-a-1) * logmul; //v04
				//hz[a] = Math.Pow(h-a-1, 64) * logmul; //v05
				//hz[a] = Math.Log(h-a-1, Math.E) * logmul; //v06
				oamp[a] = 0;
			}
			double ltick = 0;
			int shiftNext = h / 2;
			double argv = Math.PI * 2 / 44100.0;
			File.OpenRead("template.wav").Read(buf, 0, 0x2C);
			for (int x = 0; x < w; x++)
			{
				if (x % 10 == 0)
				{
					double tick = DateTime.UtcNow.Ticks / 10000000.0;
					double remain = Math.Round((w-x)*((tick-ltick)/10), 2);
					if (ltick != 0)
					{
						Console.Write((char)27 + "[1A" + (w-x) + " - " + remain + "s    \n");
					}
					ltick = tick;
				}
				for (int y = 0; y < h; y++)
				{
					double pow = img[y][x]/256.0;
					//namp[y] = (lin + 2*exp) * (vol/3);
					//namp[y] = (pow * 0.3 + pow * pow * 0.6) * vol;
					namp[y] = (pow * 0.2 + pow * pow * 0.8) * vol;
				}
				for (int s = 0; s < spp; s++)
				{
					int sum = 0;
					int smp = x * spp + s;
					double arg = smp * argv;
					for (int y = 0; y < h; y++)
					{
						double amp = oamp[y] * 0.92 + namp[y] * 0.08;
						oamp[y] = amp;
						//double amp = namp[y];
						double pt = Math.Sin(hz[y] * arg + phase[y]);
						sum += (int)(pt * amp);
					}
					byte[] write = BitConverter.GetBytes(sum);
					Array.Copy(write, 0, buf, smp*2 + 0x2C, 2);
					
					/*if (smp % 32 == 0)
					{
						phase[shiftNext] += rnd.Next(3)-1;
						shiftNext = rnd.Next(h);
					}*/
				}
			}
			byte[] tmp;
			tmp = BitConverter.GetBytes((Int32)(buf.Length - 8));
			Array.Copy(tmp, 0, buf, 4, 4);
			tmp = BitConverter.GetBytes((Int32)(buf.Length - 0x2C));
			Array.Copy(tmp, 0, buf, 40, 4);
			File.WriteAllBytes(args[0] + ".wav", buf);
			Console.Write((char)27 + "[1A :)             \n");
		}
		
		void worker(object o_offset)
		{
			int wofs = (int)o_offset;
		}
		
		// failed attempt at exponentialism
		void three(string[] args)
		{
			double amp = 0;
			args = new string[]{"brs"};
			byte[] src = File.ReadAllBytes(args[0] + ".wav");
			for (int a = 0x2C; a < src.Length; a+=2)
			{
				int v = Math.Abs(BitConverter.ToInt16(src, a));
				amp = Math.Max(amp, v);
			}
			amp = 0x7FFF / amp;
			for (int a = 0x2C; a < src.Length; a+=2)
			{
				double v = BitConverter.ToInt16(src, a);
				v *= amp;
				//v = Math.Exp(v/0x16000)*0x6000;
				v = Math.Pow(v/200.0, 2);
				byte[] u = BitConverter.GetBytes((Int16)v);
				Array.Copy(u, 0, src, a, 2);
			}
			File.WriteAllBytes(args[0] + ".norm.wav", src);
		}
		
		// first working version, piss slow though
		void two(string[] args)
		{
			args = new string[]{"brs"};
			byte[] raw = File.ReadAllBytes(args[0] + ".bmp");
			int w = BitConverter.ToInt32(raw, 0x12);
			int h = BitConverter.ToInt32(raw, 0x16);
			Console.WriteLine(w+"x"+h);
			//return;
			int bal = 0; // bmp align
			int[][] img = new int[h][];
			for (int y = h-1; y >= 0; y--)
			{
				img[y] = new int[w];
				for (int x = 0; x < w; x++)
				{
					//try {
					// 0x36; first bit; last row LTR/BGR
					img[y][x] = raw[(h-y-1)*w*3 + x*3 + bal + 0x36 - 1];
					/*Console.Write(img[y][x] == 0x00? '0':
					              img[y][x] == 0xFF? '1':
					              img[y][x] == 0xA0? 'a':
					              img[y][x] == 0xA1? 'b':
					              img[y][x] == 0xA2? 'c':'?');*/
					//}
					//catch { }
				}
				bal += (w * 3) % 2;
				//Console.WriteLine(bal);
				//if (y > 5) return;
			}
			for (int y = 0; y < h; y+=10)
			{
				for (int x = 0; x < w; x+=10)
				{
					int c = (int)((img[y][x]/256.0) * 24.0);
					Console.Write((char)27 + "[38;5;" + (232+c) + "m@");
				}
				Console.WriteLine((char)27 + "[0m");
			}
			//return;
			Random rnd = new Random();
			int[] phase = new int[h];
			for (int a = 0; a < phase.Length; a++)
			{
				phase[a] = rnd.Next(22050);
			}
			double[] oamp = new double[h];
			for (int a = 0; a < oamp.Length; a++)
			{
				oamp[a] = 0;
			}
			int left = w;
			int spp = 3675;
			//int shiftNext = 3;
			double bdw = 22000.0 / h;
			byte[] buf = new byte[spp * w * 2 + 0x2C];
			File.OpenRead("template.wav").Read(buf, 0, 0x2C);
			try
			{
			for (int i = 0; i < buf.Length - 0x2C; i+=2)
			{
				if (i % spp * 2 == 0)
				{
					left--;
					Console.Write((char)27 + "[1G" + left + " ");
				}
				int sum = 0;
				double sec = (i/2) / 44100.0;
				for (int y = 0; y < h; y++)
				{
					double amp = img[y][w-left+1] / 256.0;
					amp = oamp[y] * 0.99 + amp * 0.01;
					oamp[y] = amp;
					
					double hz = bdw * (h-y-1);
					double pt = Math.Sin(hz * sec * Math.PI * 2 + phase[y]);
					sum += (int)(pt * amp * 0xC0); //0x40
				}
				/*if (i % 315 == 0)
				{
					phase[shiftNext] += rnd.Next(3)-1;
					shiftNext = rnd.Next(bd);
				}*/
				byte[] write = BitConverter.GetBytes(sum);
				Array.Copy(write, 0, buf, i + 0x2C, 2);
			}
			}
			catch { } // fuck da police
			byte[] tmp;
			tmp = BitConverter.GetBytes((Int32)(buf.Length - 8));
			Array.Copy(tmp, 0, buf, 4, 4);
			tmp = BitConverter.GetBytes((Int32)(buf.Length - 0x2C));
			Array.Copy(tmp, 0, buf, 40, 4);
			File.WriteAllBytes(args[0] + ".wav", buf);
		}
		
		// verified OK with 440 bands
		void one(string[] args)
		{
			Random rnd = new Random();
			int[] phase = new int[9001];
			for (int a = 0; a < phase.Length; a++)
			{
				phase[a] = rnd.Next(22050);
			}
			//int shiftNext = 3;
			//int hz = Convert.ToInt32(args[0]);
			byte[] buf = new byte[44100 * 10 * 2 + 0x2C];
			File.OpenRead("template.wav").Read(buf, 0, 0x2C);
			for (int i = 0; i < buf.Length - 0x2C; i+=2)
			{
				int bd = 0;
				int sum = 0;
				double sec = (i/2) / 44100.0;
				for (int hz = 50; hz < 22050; hz += 50)
				{
					if (hz >= 10000 && hz < 15000) continue;
					double pt = Math.Sin(hz * sec * Math.PI * 2 + phase[bd++]);
					sum += (int)(pt * 0xC0); //0x40
				}
				/*if (i % 315 == 0)
				{
					phase[shiftNext] += rnd.Next(3)-1;
					shiftNext = rnd.Next(bd);
				}*/
				byte[] write = BitConverter.GetBytes(sum);
				Array.Copy(write, 0, buf, i + 0x2C, 2);
			}
			File.WriteAllBytes("gen.wav", buf);
		}
	}
}
